#import "DataSource.h"
#import "FileSystemItem.h"
#import "IconCell.h"

// gq̔f(ɂ悢@Ǝv܂)
BOOL checkBundle(NSString *name) {
	NSString *ext;
	BOOL ret = NO;
				
	ext = [name pathExtension];
	if (([ext caseInsensitiveCompare:@"app"] == NSOrderedSame) ||
			([ext caseInsensitiveCompare:@"bundle"] == NSOrderedSame) ||
			([ext caseInsensitiveCompare:@"rtfd"] == NSOrderedSame) ||
			([ext caseInsensitiveCompare:@"pbproj"] == NSOrderedSame) ||
			([ext caseInsensitiveCompare:@"pbxproj"] == NSOrderedSame) ||
			([ext caseInsensitiveCompare:@"xcode"] == NSOrderedSame) ||
			([ext caseInsensitiveCompare:@"nib"] == NSOrderedSame) ||
			([ext caseInsensitiveCompare:@"framework"] == NSOrderedSame)) {
			ret = YES;
	}

	return ret;
}

// r̊֐
NSComparisonResult CompareClassFolderFile(id element1, id element2, void *context) {
	NSFileManager *fileManager = [NSFileManager defaultManager];
	BOOL isDirPath1, isDirPath2;
	BOOL isBundle1, isBundle2;
	NSString *name1, *name2;

	name1 = [element1 lastPathComponent];
	name2 = [element2 lastPathComponent];

	isBundle1 = checkBundle(name1);
	isBundle2 = checkBundle(name2);
	
	[fileManager fileExistsAtPath:element1 isDirectory:&isDirPath1];	
	[fileManager fileExistsAtPath:element2 isDirectory:&isDirPath2];	

	if (isBundle1 == YES) {
		isDirPath1 = NO;
	}

	if (isBundle2 == YES) {
		isDirPath2 = NO;
	}

	if (isDirPath1 == YES) {
		if (isDirPath2 == YES) {
			return [name1 caseInsensitiveCompare:name2];
		} else {
			return NSOrderedAscending;
		}
	
	} else {
		if (isDirPath2 == YES) {
			return NSOrderedDescending;
		} else {
			return [name1 caseInsensitiveCompare:name2];
		}
	}
}

@implementation DataSource

// 
- (id)init {
    self = [super init];
	_outlineViewPath = nil;
	_array = nil;
    return self;
}

// eݒ
- (void)awakeFromNib {
    NSFont *aFont;
    NSTableColumn *column;
	NSCell *cell;
	IconCell *iconCell;

	// outlineView
    column = [_outlineView tableColumnWithIdentifier:@"Name"];
    iconCell = [[[IconCell alloc] init] autorelease];

    [column setDataCell:iconCell];	

	aFont = [NSFont fontWithName:@"HiraKakuPro-W3" size:10];
	[_textField setFont:aFont];

	// tableView
	column = [_tableView tableColumnWithIdentifier:@"Name"];
	// ҏW𖳌ɂȂƃ_uNbN̓삪LɂȂȂ
	[column setEditable:NO];
	iconCell = [[[IconCell alloc] init] autorelease];
    [column setDataCell:iconCell];
		
    column = [_tableView tableColumnWithIdentifier:@"Date"];
	[column setEditable:NO]; 
    cell = [column dataCell];
	[cell setFont:aFont];
	
    column = [_tableView tableColumnWithIdentifier:@"Size"];
	[column setEditable:NO];
    cell = [column dataCell];
	[cell setFont:aFont];

	// _uNbN̏ݒ
	[_tableView setTarget:self];
	[_tableView setDoubleAction:@selector(openDoubleFile:)];
}

/*
	NSOutlineView
*/

- (int)outlineView:(NSOutlineView *)outlineView numberOfChildrenOfItem:(id)item {
    return (item == nil) ? 1 : [item numberOfChildren];
}

- (BOOL)outlineView:(NSOutlineView *)outlineView isItemExpandable:(id)item {
    return (item == nil) ? YES : ([item numberOfChildren] != -1);
}

- (id)outlineView:(NSOutlineView *)outlineView child:(int)index ofItem:(id)item {
    return (item == nil) ? [FileSystemItem rootItem] : [item childAtIndex:index];
}

- (id)outlineView:(NSOutlineView *)outlineView objectValueForTableColumn:(NSTableColumn *)tableColumn byItem:(id)item {
	NSString *path;
	NSImage *icon;

	if (item == nil) {
		path = @"/";
	} else {
		path = [item fullPath];
	}	
	
	icon = [[NSWorkspace sharedWorkspace] iconForFile:path];
	[[tableColumn dataCell] setImage:icon];

    return (item == nil) ? @"/" : (id)[item relativePath];
}

// Delegate methods

- (BOOL)outlineView:(NSOutlineView *)outlineView shouldEditTableColumn:(NSTableColumn *)tableColumn item:(id)item {
    return NO;
}

- (BOOL)outlineView:(NSOutlineView *)outlineView shouldSelectItem:(id)item {
	NSImage *icon;
	NSSize size;
	
	if (_outlineViewPath != nil) {
		[_outlineViewPath release];
	}

	_outlineViewPath = [[item fullPath] retain];
	icon = [[NSWorkspace sharedWorkspace] iconForFile:_outlineViewPath];

	size = NSMakeSize(ICON_SIZE_WIDTH,ICON_SIZE_HEIGHT);
	[icon setSize:size];

	[_imageView setImage:icon];
	[_textField setStringValue:_outlineViewPath];

	[self setPathTableView:_outlineViewPath];
	[_tableView reloadData];

	return YES;
}

/*
	NSTableView
*/

- (int)numberOfRowsInTableView:(NSTableView *)aTableView {
    return [_array count];
}

- (id)tableView:(NSTableView *)aTableView
    objectValueForTableColumn:(NSTableColumn *)aTableColumn
    row:(int)rowIndex
{
	NSImage *icon;
	NSString *name, *aPath = nil; 
	NSDictionary *dictionary;
	NSFileManager *fileManager = [NSFileManager defaultManager];
	NSNumber *number;
	BOOL isDirPath;

	if (rowIndex >= 0 && rowIndex < [_array count]) { 
		aPath = [_array objectAtIndex:rowIndex];
		name = [aPath lastPathComponent];

		dictionary = [fileManager fileAttributesAtPath:aPath traverseLink:YES];
		[fileManager fileExistsAtPath:aPath isDirectory:&isDirPath];

		if ([[aTableColumn identifier] isEqual:@"Name"]) {

			icon = [[NSWorkspace sharedWorkspace] iconForFile:aPath];
			[[aTableColumn dataCell] setImage:icon];

            return name;
		} else if ([[aTableColumn identifier] isEqual:@"Size"]) {
			if (isDirPath == YES) { 
				return @"Folder";
			} else {
				number = [dictionary objectForKey:NSFileSize];
				return number;
			}
		} else if ([[aTableColumn identifier] isEqual:@"Date"]) {
			NSDate *date;
			
			date = [dictionary objectForKey:NSFileModificationDate];

			return date;
		}
	}

    return nil;
}

/*
	TableView̓eXV
*/

- (void)setPathTableView: (NSString *)fullPath {
        NSFileManager *fileManager = [NSFileManager defaultManager];
		NSArray *array = [fileManager directoryContentsAtPath:fullPath];
		NSMutableArray *newArray;
		int cnt;

		if (_array != nil) {
			[_array release];
		}
		_array = [[NSMutableArray array] retain];
		
		for (cnt = 0; cnt < [array count]; cnt++) {
			NSString *path;
			NSString *name;
			BOOL isDirPath;
				
			name = [array objectAtIndex:cnt];
			path = [fullPath stringByAppendingPathComponent:name];

			[fileManager fileExistsAtPath:path isDirectory:&isDirPath];
			[_array addObject:path];
		}
		
		newArray = [[_array sortedArrayUsingFunction:CompareClassFolderFile context:NULL] retain];
		[_array release];
		_array = newArray;
}

// _uNbN̏
- (void)openDoubleFile:(id)sender {
	NSWorkspace *wspace = [NSWorkspace sharedWorkspace];
	NSString *path;
	int row;

	row = [_tableView selectedRow];
	if (row != -1) {
		path = [_array objectAtIndex:row];
		[wspace openFile:path];
	}
}

// zԂ
- (NSMutableArray *)tableViewArray {
	return _array;
}

// L^pXԂ
- (NSString *)outlineViewPath {
	return _outlineViewPath;
}

@end

