#import "FileSystemItem.h"
#import "DataSource.h"

/*
	/Developer/Examples/AppKit/OutlineView
	/Developer/Examples/AppKit/OutlineView/FileSystemItem.h
	/Developer/Examples/AppKit/OutlineView/FileSystemItem.m
	QlɂĂ܂B
	(Mac OS X Xcode Tools@CXg[ĂKv܂B)
*/

@implementation FileSystemItem

static FileSystemItem *rootItem = nil;

#define IsALeafNode ((id)-1)

- (id)initWithPath:(NSString *)path parent:(FileSystemItem *)obj {
    if (self = [super init]) {
        relativePath = [[path lastPathComponent] copy];
        parent = obj;
    }
    return self;
}

+ (FileSystemItem *)rootItem {
   if (rootItem == nil) rootItem = [[FileSystemItem alloc] initWithPath:@"/" parent:nil];
   return rootItem;       
}

- (void)dealloc {
    if (children != IsALeafNode) [children release];
    [relativePath release];
    [super dealloc];
}

// Creates and returns the array of children
// Loads children incrementally
//
- (NSArray *)children {
    if (children == NULL) {
        NSFileManager *fileManager = [NSFileManager defaultManager];
        NSString *fullPath = [self fullPath];
		BOOL isDir;
        BOOL valid;
		
		valid = [fileManager fileExistsAtPath:fullPath isDirectory:&isDir];
		
  		if (valid && isDir) {
            NSArray *array = [fileManager directoryContentsAtPath:fullPath];
            int cnt, numChildren = [array count];

//			children = [[NSMutableArray alloc] initWithCapacity:numChildren];
			children = [[NSMutableArray array] retain];

            for (cnt = 0; cnt < numChildren; cnt++) {
				NSString *path;
				NSString *name;
				BOOL isDirPath, isBunndle;
				
				name = [array objectAtIndex:cnt];
				path = [fullPath stringByAppendingPathComponent:name];
				[fileManager fileExistsAtPath:path isDirectory:&isDirPath];

				isBunndle = checkBundle(name);
				if ((isDirPath == YES) && (isBunndle == NO)) {
					[children addObject:[[FileSystemItem alloc] initWithPath:name parent:self]];
				}
			}
        } else {
            children = IsALeafNode;
        }
    }
    return children;
}

- (NSString *)relativePath {
    return relativePath;
}

- (NSString *)fullPath {
    return parent ? [[parent fullPath] stringByAppendingPathComponent:relativePath] : relativePath;
}

- (FileSystemItem *)childAtIndex:(int)n {
    return [[self children] objectAtIndex:n];
}

- (int)numberOfChildren {
    id tmp = [self children];
    return (tmp == IsALeafNode) ? (-1) : [tmp count];
}


@end


